// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Block.proto

#ifndef PROTOBUF_INCLUDED_Block_2eproto
#define PROTOBUF_INCLUDED_Block_2eproto

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3006001
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3006001 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/inlined_string_field.h>
#include <google/protobuf/metadata_lite.h>
#include <google/protobuf/message_lite.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include "Tile.pb.h"
#include "Plant.pb.h"
// @@protoc_insertion_point(includes)
#define PROTOBUF_INTERNAL_EXPORT_protobuf_Block_2eproto 

namespace protobuf_Block_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[2];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
}  // namespace protobuf_Block_2eproto
namespace dfproto {
class Block;
class BlockDefaultTypeInternal;
extern BlockDefaultTypeInternal _Block_default_instance_;
class MiniBlock;
class MiniBlockDefaultTypeInternal;
extern MiniBlockDefaultTypeInternal _MiniBlock_default_instance_;
}  // namespace dfproto
namespace google {
namespace protobuf {
template<> ::dfproto::Block* Arena::CreateMaybeMessage<::dfproto::Block>(Arena*);
template<> ::dfproto::MiniBlock* Arena::CreateMaybeMessage<::dfproto::MiniBlock>(Arena*);
}  // namespace protobuf
}  // namespace google
namespace dfproto {

// ===================================================================

class Block : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:dfproto.Block) */ {
 public:
  Block();
  virtual ~Block();

  Block(const Block& from);

  inline Block& operator=(const Block& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  Block(Block&& from) noexcept
    : Block() {
    *this = ::std::move(from);
  }

  inline Block& operator=(Block&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const Block& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const Block* internal_default_instance() {
    return reinterpret_cast<const Block*>(
               &_Block_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    0;

  void Swap(Block* other);
  friend void swap(Block& a, Block& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline Block* New() const final {
    return CreateMaybeMessage<Block>(NULL);
  }

  Block* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<Block>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const Block& from);
  void MergeFrom(const Block& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(Block* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .dfproto.Tile tile = 4;
  int tile_size() const;
  void clear_tile();
  static const int kTileFieldNumber = 4;
  ::dfproto::Tile* mutable_tile(int index);
  ::google::protobuf::RepeatedPtrField< ::dfproto::Tile >*
      mutable_tile();
  const ::dfproto::Tile& tile(int index) const;
  ::dfproto::Tile* add_tile();
  const ::google::protobuf::RepeatedPtrField< ::dfproto::Tile >&
      tile() const;

  // repeated .dfproto.Plant plant = 5;
  int plant_size() const;
  void clear_plant();
  static const int kPlantFieldNumber = 5;
  ::dfproto::Plant* mutable_plant(int index);
  ::google::protobuf::RepeatedPtrField< ::dfproto::Plant >*
      mutable_plant();
  const ::dfproto::Plant& plant(int index) const;
  ::dfproto::Plant* add_plant();
  const ::google::protobuf::RepeatedPtrField< ::dfproto::Plant >&
      plant() const;

  // required uint32 x = 1;
  bool has_x() const;
  void clear_x();
  static const int kXFieldNumber = 1;
  ::google::protobuf::uint32 x() const;
  void set_x(::google::protobuf::uint32 value);

  // required uint32 y = 2;
  bool has_y() const;
  void clear_y();
  static const int kYFieldNumber = 2;
  ::google::protobuf::uint32 y() const;
  void set_y(::google::protobuf::uint32 value);

  // required uint32 z = 3;
  bool has_z() const;
  void clear_z();
  static const int kZFieldNumber = 3;
  ::google::protobuf::uint32 z() const;
  void set_z(::google::protobuf::uint32 value);

  // @@protoc_insertion_point(class_scope:dfproto.Block)
 private:
  void set_has_x();
  void clear_has_x();
  void set_has_y();
  void clear_has_y();
  void set_has_z();
  void clear_has_z();

  // helper for ByteSizeLong()
  size_t RequiredFieldsByteSizeFallback() const;

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  ::google::protobuf::RepeatedPtrField< ::dfproto::Tile > tile_;
  ::google::protobuf::RepeatedPtrField< ::dfproto::Plant > plant_;
  ::google::protobuf::uint32 x_;
  ::google::protobuf::uint32 y_;
  ::google::protobuf::uint32 z_;
  friend struct ::protobuf_Block_2eproto::TableStruct;
};
// -------------------------------------------------------------------

class MiniBlock : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:dfproto.MiniBlock) */ {
 public:
  MiniBlock();
  virtual ~MiniBlock();

  MiniBlock(const MiniBlock& from);

  inline MiniBlock& operator=(const MiniBlock& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  MiniBlock(MiniBlock&& from) noexcept
    : MiniBlock() {
    *this = ::std::move(from);
  }

  inline MiniBlock& operator=(MiniBlock&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const MiniBlock& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const MiniBlock* internal_default_instance() {
    return reinterpret_cast<const MiniBlock*>(
               &_MiniBlock_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    1;

  void Swap(MiniBlock* other);
  friend void swap(MiniBlock& a, MiniBlock& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline MiniBlock* New() const final {
    return CreateMaybeMessage<MiniBlock>(NULL);
  }

  MiniBlock* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<MiniBlock>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const MiniBlock& from);
  void MergeFrom(const MiniBlock& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(MiniBlock* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated uint32 tile = 1 [packed = true];
  int tile_size() const;
  void clear_tile();
  static const int kTileFieldNumber = 1;
  ::google::protobuf::uint32 tile(int index) const;
  void set_tile(int index, ::google::protobuf::uint32 value);
  void add_tile(::google::protobuf::uint32 value);
  const ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >&
      tile() const;
  ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >*
      mutable_tile();

  // repeated uint32 liquid_type = 2 [packed = true];
  int liquid_type_size() const;
  void clear_liquid_type();
  static const int kLiquidTypeFieldNumber = 2;
  ::google::protobuf::uint32 liquid_type(int index) const;
  void set_liquid_type(int index, ::google::protobuf::uint32 value);
  void add_liquid_type(::google::protobuf::uint32 value);
  const ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >&
      liquid_type() const;
  ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >*
      mutable_liquid_type();

  // repeated uint32 flow_size = 3 [packed = true];
  int flow_size_size() const;
  void clear_flow_size();
  static const int kFlowSizeFieldNumber = 3;
  ::google::protobuf::uint32 flow_size(int index) const;
  void set_flow_size(int index, ::google::protobuf::uint32 value);
  void add_flow_size(::google::protobuf::uint32 value);
  const ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >&
      flow_size() const;
  ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >*
      mutable_flow_size();

  // @@protoc_insertion_point(class_scope:dfproto.MiniBlock)
 private:

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  ::google::protobuf::RepeatedField< ::google::protobuf::uint32 > tile_;
  mutable int _tile_cached_byte_size_;
  ::google::protobuf::RepeatedField< ::google::protobuf::uint32 > liquid_type_;
  mutable int _liquid_type_cached_byte_size_;
  ::google::protobuf::RepeatedField< ::google::protobuf::uint32 > flow_size_;
  mutable int _flow_size_cached_byte_size_;
  friend struct ::protobuf_Block_2eproto::TableStruct;
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// Block

// required uint32 x = 1;
inline bool Block::has_x() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void Block::set_has_x() {
  _has_bits_[0] |= 0x00000001u;
}
inline void Block::clear_has_x() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void Block::clear_x() {
  x_ = 0u;
  clear_has_x();
}
inline ::google::protobuf::uint32 Block::x() const {
  // @@protoc_insertion_point(field_get:dfproto.Block.x)
  return x_;
}
inline void Block::set_x(::google::protobuf::uint32 value) {
  set_has_x();
  x_ = value;
  // @@protoc_insertion_point(field_set:dfproto.Block.x)
}

// required uint32 y = 2;
inline bool Block::has_y() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
inline void Block::set_has_y() {
  _has_bits_[0] |= 0x00000002u;
}
inline void Block::clear_has_y() {
  _has_bits_[0] &= ~0x00000002u;
}
inline void Block::clear_y() {
  y_ = 0u;
  clear_has_y();
}
inline ::google::protobuf::uint32 Block::y() const {
  // @@protoc_insertion_point(field_get:dfproto.Block.y)
  return y_;
}
inline void Block::set_y(::google::protobuf::uint32 value) {
  set_has_y();
  y_ = value;
  // @@protoc_insertion_point(field_set:dfproto.Block.y)
}

// required uint32 z = 3;
inline bool Block::has_z() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
inline void Block::set_has_z() {
  _has_bits_[0] |= 0x00000004u;
}
inline void Block::clear_has_z() {
  _has_bits_[0] &= ~0x00000004u;
}
inline void Block::clear_z() {
  z_ = 0u;
  clear_has_z();
}
inline ::google::protobuf::uint32 Block::z() const {
  // @@protoc_insertion_point(field_get:dfproto.Block.z)
  return z_;
}
inline void Block::set_z(::google::protobuf::uint32 value) {
  set_has_z();
  z_ = value;
  // @@protoc_insertion_point(field_set:dfproto.Block.z)
}

// repeated .dfproto.Tile tile = 4;
inline int Block::tile_size() const {
  return tile_.size();
}
inline ::dfproto::Tile* Block::mutable_tile(int index) {
  // @@protoc_insertion_point(field_mutable:dfproto.Block.tile)
  return tile_.Mutable(index);
}
inline ::google::protobuf::RepeatedPtrField< ::dfproto::Tile >*
Block::mutable_tile() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.Block.tile)
  return &tile_;
}
inline const ::dfproto::Tile& Block::tile(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.Block.tile)
  return tile_.Get(index);
}
inline ::dfproto::Tile* Block::add_tile() {
  // @@protoc_insertion_point(field_add:dfproto.Block.tile)
  return tile_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::dfproto::Tile >&
Block::tile() const {
  // @@protoc_insertion_point(field_list:dfproto.Block.tile)
  return tile_;
}

// repeated .dfproto.Plant plant = 5;
inline int Block::plant_size() const {
  return plant_.size();
}
inline ::dfproto::Plant* Block::mutable_plant(int index) {
  // @@protoc_insertion_point(field_mutable:dfproto.Block.plant)
  return plant_.Mutable(index);
}
inline ::google::protobuf::RepeatedPtrField< ::dfproto::Plant >*
Block::mutable_plant() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.Block.plant)
  return &plant_;
}
inline const ::dfproto::Plant& Block::plant(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.Block.plant)
  return plant_.Get(index);
}
inline ::dfproto::Plant* Block::add_plant() {
  // @@protoc_insertion_point(field_add:dfproto.Block.plant)
  return plant_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::dfproto::Plant >&
Block::plant() const {
  // @@protoc_insertion_point(field_list:dfproto.Block.plant)
  return plant_;
}

// -------------------------------------------------------------------

// MiniBlock

// repeated uint32 tile = 1 [packed = true];
inline int MiniBlock::tile_size() const {
  return tile_.size();
}
inline void MiniBlock::clear_tile() {
  tile_.Clear();
}
inline ::google::protobuf::uint32 MiniBlock::tile(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.MiniBlock.tile)
  return tile_.Get(index);
}
inline void MiniBlock::set_tile(int index, ::google::protobuf::uint32 value) {
  tile_.Set(index, value);
  // @@protoc_insertion_point(field_set:dfproto.MiniBlock.tile)
}
inline void MiniBlock::add_tile(::google::protobuf::uint32 value) {
  tile_.Add(value);
  // @@protoc_insertion_point(field_add:dfproto.MiniBlock.tile)
}
inline const ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >&
MiniBlock::tile() const {
  // @@protoc_insertion_point(field_list:dfproto.MiniBlock.tile)
  return tile_;
}
inline ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >*
MiniBlock::mutable_tile() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.MiniBlock.tile)
  return &tile_;
}

// repeated uint32 liquid_type = 2 [packed = true];
inline int MiniBlock::liquid_type_size() const {
  return liquid_type_.size();
}
inline void MiniBlock::clear_liquid_type() {
  liquid_type_.Clear();
}
inline ::google::protobuf::uint32 MiniBlock::liquid_type(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.MiniBlock.liquid_type)
  return liquid_type_.Get(index);
}
inline void MiniBlock::set_liquid_type(int index, ::google::protobuf::uint32 value) {
  liquid_type_.Set(index, value);
  // @@protoc_insertion_point(field_set:dfproto.MiniBlock.liquid_type)
}
inline void MiniBlock::add_liquid_type(::google::protobuf::uint32 value) {
  liquid_type_.Add(value);
  // @@protoc_insertion_point(field_add:dfproto.MiniBlock.liquid_type)
}
inline const ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >&
MiniBlock::liquid_type() const {
  // @@protoc_insertion_point(field_list:dfproto.MiniBlock.liquid_type)
  return liquid_type_;
}
inline ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >*
MiniBlock::mutable_liquid_type() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.MiniBlock.liquid_type)
  return &liquid_type_;
}

// repeated uint32 flow_size = 3 [packed = true];
inline int MiniBlock::flow_size_size() const {
  return flow_size_.size();
}
inline void MiniBlock::clear_flow_size() {
  flow_size_.Clear();
}
inline ::google::protobuf::uint32 MiniBlock::flow_size(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.MiniBlock.flow_size)
  return flow_size_.Get(index);
}
inline void MiniBlock::set_flow_size(int index, ::google::protobuf::uint32 value) {
  flow_size_.Set(index, value);
  // @@protoc_insertion_point(field_set:dfproto.MiniBlock.flow_size)
}
inline void MiniBlock::add_flow_size(::google::protobuf::uint32 value) {
  flow_size_.Add(value);
  // @@protoc_insertion_point(field_add:dfproto.MiniBlock.flow_size)
}
inline const ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >&
MiniBlock::flow_size() const {
  // @@protoc_insertion_point(field_list:dfproto.MiniBlock.flow_size)
  return flow_size_;
}
inline ::google::protobuf::RepeatedField< ::google::protobuf::uint32 >*
MiniBlock::mutable_flow_size() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.MiniBlock.flow_size)
  return &flow_size_;
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace dfproto

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_INCLUDED_Block_2eproto
